#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <vs1000.h>

#include <player.h>
#include <mappertiny.h>
#include <minifat.h>
#include <vsNand.h>
#include <dev1000.h>

extern struct FsNandPhys fsNandPhys;
extern struct FsPhysical *ph;
extern struct FsMapper *map;
extern struct Codec *cod;

#define NandSelect() USEX(GPIO0_ODATA) &= ~GPIO0_CS1
#define NandDeselect() USEX(GPIO0_ODATA) |= GPIO0_CS1
void NandPutCommand (register __a0 u_int16 command);
void NandPutBlockAddress(register __c u_int32 addr);
void NandPutDataAddress(register __c u_int32 addr);
void NandPutLargePageSpareAddress(register __c u_int32 addr);
u_int16 NandGetStatus(void);
void NandPutAddressOctet(register __a0 u_int16 address);
void NandGetOctets(register __c0 s_int16 length, register __i2 u_int16 *buf);

u_int16 NandGetIdent(void){
  u_int16 ident[4];
  NandDeselect();
  NandSelect();
  NandPutCommand(NAND_OP_READ_SIGNATURE);
  NandPutAddressOctet(0);
  NandGetOctets(8,ident);
  NandDeselect();
  fputs("Nand Signature: ",stdout);
  /*
    2cdc 9095 5400 MT29F4G08AAA
    ecd3 14a5 64ec K9G8G08U0A-PCB0   8Gb MLC  type=3 bl=9 sz=21
    ecd5 55a5 68ec K9LAG08U0A-PCB0  16Gb MLC  type=3 bl=9 sz=22 (2 dies)
    add3 14a5 34ad HY27UT088G2A-TPC8 8Gb MLC  type=3 bl=9 sz=21
    add3 14a5 64ad HY27UU08AG5M          MLC  type=3 bl=9 sz=22(21) (2 /CS, 2 R/B)
  */
  /*
    1st byte: maker code
    2nd byte: device code
    3rd & 4th byte: parameters
   */
#if 1
  {
    register int i;
    for (i=0; i<3; i++){
      puthex(ident[i]);
    }
  }
  fputs("\n",stdout);
#endif

#if 1
  puthex(1 << ((ident[1]>>8) & 3));
  puts("dies");
  puthex(((ident[1] >> 10) & 3) + 1);
  puts("bits/cell");
  puthex(1 << ((ident[1] >> 12) & 3));
  puts("sim.prog.pages");
  puts((ident[1] & 0x4000U) ? "Interleaved program" : "No interleaved program");
  puts((ident[1] & 0x8000U) ? "Cache program" : "No cache program");
  puthex((ident[1] & 3)+1);
  puts("kB page");
  puthex(64 << ((ident[1] >> 4) & 3));
  puts("kB block");
#endif
  return ident[0];
}
#include <audio.h>
#include <player.h>


char in[200];
void main(void) {
    //ph = FsPhNandCreate(1);
#if 1
    clockX = 7;
//    SetRate(1000);
    voltages[voltIoPlayer] = 30;
    PowerSetVoltages(&voltages[voltCorePlayer]);
#endif

#if 0
    /* In case we have parallel display, deassert CS */
    PERIP(GPIO0_DDR) |= 0x4000;
    PERIP(GPIO0_SET_MASK) = 0x4000; //CS2
#endif

#if 0
    ((struct FsNandPhys *)ph)->nandType = 2;
    if ((s_int16)((struct FsNandPhys *)ph)->nandType < 0) {
	((struct FsNandPhys *)ph)->nandType = 2;
	((struct FsNandPhys *)ph)->waitns = 200;
    }
#endif
    ((struct FsNandPhys *)ph)->nandType = 3;
    NandGetIdent();

    /* write image */
    {
	FILE *fp;
	int i;
	int errs;
    again:
	errs = 0;
	fp = fopen("input.img", "rb");
	if (fp) {
	    u_int32 sector = 0;

	    puts("\nWriting");
	    PERIP(INT_ENABLEL) &= ~INTF_RX;
	    memset(mallocAreaX, -1, 2048/2);
#ifndef VERIFY_ONLY
	    while (fread(mallocAreaX, 1, 2048/2, fp)) {
#if 1
		if (sector == 0) {
		    /* Read flash parameters from image */

		    /* read first sector */
		    ph->Read(ph, 0, 1, minifatBuffer, NULL);
		    if (minifatBuffer[0] == (('V'<<8)|'L') &&
			minifatBuffer[1] == (('S'<<8)|'I') &&
			(u_int16)minifatBuffer[2] < 6) {
			/* NAND info not needed, use it */
			puts("info from FLASH ok");
			memcpy(mallocAreaX, minifatBuffer, 5);
			/* 10 bytes = 5 words */
		    } else {
			puthex(minifatBuffer[0]);
			puthex(minifatBuffer[1]);
			puthex(minifatBuffer[2]);
			puthex(minifatBuffer[3]);
			puthex(minifatBuffer[4]);
			puts("=flash");
			puts("info from file");
			/* NAND info not present, use from file */
		    }

		    fsNandPhys.nandType = mallocAreaX[2];
		    ph->eraseBlockSize = 1 << (mallocAreaX[3]>>8);
		    ph->eraseBlocks = 1L << ((mallocAreaX[3] & 255) - (mallocAreaX[3]>>8));

		    puthex(fsNandPhys.nandType);
		    puts("=type");
		    puthex(mallocAreaX[0]);
		    puthex(mallocAreaX[1]);
		    puthex(mallocAreaX[2]);
		    puthex(mallocAreaX[3]);
		    puthex(mallocAreaX[4]);
		    puts("=flash");


		    puthex(((struct FsNandPhys *)ph)->waitns);
		    puts("=ws");
		    puthex(ph->eraseBlockSize);
		    puts("=eraseBlockSize");
		    puthex(ph->eraseBlocks);
		    puts("=eraseBlocks");

		    ph->Erase(ph, 0);
		}
#endif
		memset(minifatBuffer, -1, 4*16/2);
		if (fsNandPhys.nandType & 1) {
		    if (LargePageWrite(sector, mallocAreaX, minifatBuffer)) {
			puts("WrError");
		    }
		} else {
		    /* Small-page! */
		    if (ph->Write(ph, sector, 4, mallocAreaX, minifatBuffer)
			!= 4) {
			puts("WrError");
		    }
		}
#if 0
		for (i=0;i<25/*256*/;i++) {
		    BusyWait10();
		}
#endif
		sector += 4;
		memset(mallocAreaX, -1, 2048/2);
	    }
	    //fclose(fp);
	    puthex(sector);
	    puts("=sectors written");
#endif
	    fseek(fp, 0, SEEK_SET);
	    sector = 0;

	    puts("Verifying");
	    while (fread(mallocAreaX, 1, 512/2, fp)) {
		if (ph->Read(ph, sector, 1, mallocAreaX+256, minifatBuffer) != 1)
		    puts("read error");

		if ((sector == 0 &&
		     memcmp(mallocAreaX+5, mallocAreaX+256+5, 512/2-5)) ||
		    (sector != 0 &&
		     memcmp(mallocAreaX, mallocAreaX+256, 512/2))) {
		    puthex(sector);
		    puts("verify error");
		    for (i=0;i<256;i++) {
			if (mallocAreaX[i] != mallocAreaX[256+i]) {
			    errs++;
			}
#if 0 //ndef VERIFY_ONLY
			if (mallocAreaX[i] != mallocAreaX[256+i]) {
			    puthex(i);
			    puthex(mallocAreaX[i]);
			    puthex(mallocAreaX[256+i]);
			    puts("");
			}
#endif
		    }
		}
		sector += 1;
		memset(mallocAreaX, -1, 512/2);
	    }
	    fclose(fp);
	    PERIP(INT_ENABLEL) |= INTF_RX;
	} else {
		puts("Could not open file input.img\n");
		errs = 1;
	}
	if (errs) {
	    puthex(errs);
	    puts("=errs, programming failed");
#if 0
	    ((struct FsNandPhys *)ph)->waitns++;
	    goto again;
#endif
	} else {
	    puts("Programming Finished Successfully!");
	    USEX(WDOG_CONFIG) = 2;
	    USEX(WDOG_RESET) = 0x4ea9; /*Activate watchdog*/
	    while (1)
		;
	}
    }
}
