/*
  Copyright 2014 VLSI Solution Oy. Absolutely no warranty.
*/  
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <vs1000.h>
#include <audio.h>
#include <mappertiny.h>
#include <minifat.h>
#include <codec.h>
#include <vsNand.h>
#include <player.h>
#include <codecvorbis.h>
#include <usblowlib.h>
#include <vstypes.h>


#define USE_THREE_BUTTONS /*PWRBTN: play/pause/off  IO0:prev/voldown IO1:next/volup IO0+IO1:shuffle toggle/earspeaker select*/
#define USE_USB_DISABLE_FILE /* DISABLED.USB in the disk will disable USB mode */

#define GAPLESS //try to avoid all delays between files
//#define USE_WAV /* Play linear wav files using CodMicroWav from libdev1000.*/

/* generic support functions */
void putstrp(register __i0 u_int16 *packedStr);
extern struct CodecServices cs;

#define USE_USB
#define PATCH_EJECT    /* 'eject' shuts down power */
//#define PATCH_UNIT_READY /* detects card removed during USB mode */
#define PATCH_SENSE      /* patches REQUEST_SENSE */


#include <dev1000.h>

#ifdef USE_DEBUG
static char hex[] = "0123456789ABCDEF";
void puthex(u_int16 d) {
    register int i;
    char mem[5];
    for (i=0;i<4;i++) {
	mem[i] = hex[(d>>12)&15];
	d <<= 4;
    }
    mem[4] = '\0';
    fputs(mem, stdout);
}
#endif


extern struct FsNandPhys fsNandPhys;
extern struct FsPhysical *ph;
extern struct FsMapper *map;
extern struct Codec *cod;
extern struct CodecServices cs;
//extern u_int16 codecVorbis[];

#ifdef USE_USB
#if defined(PATCH_EJECT) || defined(PATCH_UNIT_READY) || defined(PATCH_SENSE)
#include <scsi.h>
#endif
#ifdef PATCH_EJECT
int startUnit = 1;
#endif

/*
  We replace the MassStorage() functionality.
 */
auto void MyMassStorage(void) {
  map->Delete(map); /* delete tiny mapper */
  PowerSetVoltages(&voltages[voltCoreUSB]);
  /** a 2.5ms-10ms delay to let the voltages change (rise) */
  BusyWait10();

  if (((struct FsNandPhys *)ph)->nandType < 8) {
      map = FsMapFlCreate(ph, 0);
      //CleanDisk(0);
  } else {
      map = FsMapRamCreate((void *)mallocAreaY/*36 blocks*/, 0);
  }
#ifdef USE_DEBUG
  puts("Entering USB");
#endif
  LoadCheck(NULL, 1); /* 4.0x clock required! */
  InitUSB(USB_MASS_STORAGE);  

  while (1) {
    USBHandler();

    /* If no SOF in such a long time.. */
    if (USBWantsSuspend()) {
      /* Do we seem to be detached?
	 Note: Now also requires USBWantsSuspend() to return TRUE! */
      if (USBIsDetached()) {
#ifdef USE_DEBUG
	puts("Detached");
#endif
	break;
      }
#ifdef USE_DEBUG
      puts("Suspend");
#endif
      /*Suspend is not supported anyway*/
      USB.lastSofTime = ReadTimeCount();
    }
#ifdef PATCH_EJECT
    if (startUnit == 2) {
	break;
    }
#endif
  }
#ifdef USE_DEBUG
  puts("Leaving USB");
#endif
//  hwSampleRate = 1; /* Forces FREQCTL update at next SetRate() */
  PERIP(SCI_STATUS) &= ~SCISTF_USB_PULLUP_ENA; /* Take us 'out of the bus' */
  PERIP(USB_CONFIG) = 0x8000U; /* Reset USB */
  map->Flush(map, 1);

  /* Clean unused FAT sectors. If RAMDISK, search for boot file */
  //CleanDisk(((struct FsNandPhys *)ph)->nandType >= 8);
  map->Delete(map);
  map = FsMapTnCreate(ph, 0); /* re-initialize tiny mapper */

  LoadCheck(NULL,0); //added in VS1000D: change clock before changing voltages!
  /* Set player voltages. No need to wait for the voltages to drop. */
  PowerSetVoltages(&voltages[voltCorePlayer]);
#ifdef PATCH_EJECT
  /* If 'eject', power down */
  if (startUnit == 2) {
#ifdef UART_CONTROL
      putstrp("\pEjected - Power Off\n\n");
#endif/*UART_CONTROL*/
      PowerOff();
  }
#endif
}
#endif /*USE_USB*/


#ifdef GAPLESS

#ifndef COD_VORBIS_GENERAL_H
#define COD_VORBIS_GENERAL_H
#include <vstypes.h>
#include <codec.h>
/** Maximum number of channels handled by the VORBIS codec. */
#define COD_VORBIS_MAX_CHANNELS 2
/**
   Vorbis Codec extensions to the basic Codec structure.
   Doesn't yet allow re-entrancy.
*/
struct CodecVorbis {
  /** Basic Codec structure. */
  struct Codec c;
  /** Temporary flag until re-entrancy is corrected. */
  s_int16 used;
  /** Internal variables */
  u_int16 state;
  /* ---------------- setup - -------------------- */
  u_int16 audioChannels;
  u_int32 audioSampleRate;
  u_int32 bitRateMaximum;
  u_int32 bitRateNominal;
  u_int32 bitRateMinimum;
  u_int16 blockSize[2];
  const u_int16 __y *window[2];
  u_int16 codeBooks;
  struct CodeBook *codeBook;
  u_int16 floors;
  struct Floor1 __y *floor;
  u_int16 residues;
  struct Residue *residue;
  u_int16 maps;
  struct Map *map;
  u_int16 modes;
  struct Mode *mode;
  /* ---------------- decode -------------------- */
  /** Mode number */
  u_int16 modeNumber;
  /** Type of previous window */
  s_int16 prevWinType;
  /** Byte offset to the point where actual AUDIO data begins */
  u_int32 audioBegins;
  /** How many bits downshifted for last frame. */
  s_int16 oldFrameDownshift[COD_VORBIS_MAX_CHANNELS];
  /** How many bits could have been downshifted for last frame. */
  s_int16 oldFramePotentialDownshift[COD_VORBIS_MAX_CHANNELS];
};
#endif /* !COD_VORBIS_GENERAL_H */
extern struct CodecVorbis codecVorbis;
struct Codec *CodVorbisCreate(void);
extern u_int16 ogg[];
//extern struct CodVOgg ogg;
extern s_int16 vFirstFrame;
auto s_int16 OggSeekHeader(register u_int32 pos);
#endif/*GAPLESS*/


//////////////////////////////////////////////////////////////////////////////
//See sdplayer.c for PlayGapless code which supports WAV and gapless and loop
//////////////////////////////////////////////////////////////////////////////


#ifdef USE_WAV
#include <codecmicrowav.h>
#include <dev1000.h>
extern struct CodecServices cs;
extern struct Codec *cod;
enum CodecError PlayWavOrOggFile(void) {
  register enum CodecError ret;
  const char *eStr;
#ifdef USE_USB
  //CodMicroWavCreate(); /*We know it does nothing */
  /* call Decode directly to save some instructions */
  ret = CodMicroWavDecode(cod, &cs, &eStr);
  //CodMicroWavDelete(cod); /*We know it does nothing */
  if (ret != ceFormatNotFound) {
      return ret;
  }
  /* If failed, seek to the beginning and try Ogg Vorbis decoding. */
  cs.Seek(&cs, 0, SEEK_SET);
#else
  LoadCheck(NULL, 0); /* higher clock, but 4.0x not absolutely required */


#ifdef GAPLESS
  if (codecVorbis.audioBegins) {
      u_int16 data[2];
      Seek(codecVorbis.audioBegins);
      ReadFile(data, 0, 4);
      if (data[0] == 0x4f67 && data[1] == 0x6753) {
	  /* 'OggS', assume the same parameters, skip
	     Vorbis decoder init. */
	  const char *eStr;
	  register s_int16 res = OggSeekHeader(codecVorbis.audioBegins);
	  ogg[1]/*.headerTypeFlag*/ = 0;
	  ogg[6]/*.streamSerialNumber*/ = 0;
	  ogg[7]/*.streamSerialNumber*/ = 0;
	  ogg[14]/*.cont*/ = 0;
	  //ogg.headerTypeFlag = 0;
	  //ogg.cont = 0;
	  vFirstFrame = 1;
	  cs.playTimeSeconds = 0;
	  cs.playTimeSamples = 0;
//putch('+');
#ifdef HAS_PATCHCODVORBISDECODE
	  /*available in latest dev1000.h */
	  PatchCodVorbisDecode(&codecVorbis, &cs, &eStr, 0); 
#else
	  /*TODO: call Decode() with silentchannelpatches */
	  CodVorbisDecode(&codecVorbis, &cs, &eStr); 
#endif
      } else {
	  /* 'OggS' Not found, must be a file with
	     different parameters (or WAV) */
//putch('-');
	  Seek(0);
      }
  }
#endif/*GAPLESS*/


  if ((cod = CodMicroWavCreate())) {
      ret = cod->Decode(cod, &cs, &eStr);
      cod->Delete(cod);
#if 0
      if (earSpeakerReg) {
	  register int i;
	  for (i=0;i<DEFAULT_AUDIO_BUFFER_SAMPLES/(sizeof(tmpBuf)/2);i++) {
	      /* Must be memset each time, because effects like EarSpeaker are
		 performed in-place in the buffer */
	      memset(tmpBuf, 0, sizeof(tmpBuf));
	      AudioOutputSamples(tmpBuf, sizeof(tmpBuf)/2);
	  }
      }
#endif
      if (ret != ceFormatNotFound) {
#ifdef GAPLESS
	  codecVorbis.audioBegins = 0;
#endif
	  return ret;
      }
      /* If failed, seek to the beginning and try Ogg Vorbis decoding. */
      cs.Seek(&cs, 0, SEEK_SET);
  }
#endif

  return PatchPlayCurrentFile();
}
#endif/*USE_WAV*/


#ifdef USE_USB
#if defined(PATCH_EJECT) || defined(PATCH_UNIT_READY) || defined(PATCH_SENSE)
#include <scsi.h>
auto u_int16 NewDiskProtocolCommand(register __i2 u_int16 *cmd) {
    __y u_int16 c = (cmd[OPERATION_CODE] & 0xff);
#if defined(PATCH_EJECT)
    if (c == SCSI_START_STOP_UNIT) {
	/* 0:OP 1:imm0 2:res 3:res 4:power7-4 res3-2 loej1 start0 5:control */
	startUnit = cmd[4] & 1;
    } else if (startUnit == 0) {
	/* The next command after STOP UNIT will not be serviced
	   fully because we will turn ourselves off. */
	startUnit = 2;
    }
#endif
#if defined(PATCH_UNIT_READY)
    if (c == SCSI_TEST_UNIT_READY) {
	//SCSI.Status = SCSI_REQUEST_ERROR; /* report error at least once! */
	SCSI.State = SCSI_SEND_STATUS;
	return -1; /*done processing*/
    }
#endif
#if defined(PATCH_SENSE)
    if (c == SCSI_REQUEST_SENSE) {
	/* patch a bug -- sense was written to the wrong buffer */
	SCSI.DataBuffer[0] = 0x7000;
	SCSI.DataOutBuffer = SCSI.DataBuffer;
	SCSI.DataOutSize = 18; /*Windows requires 18.*/
	SCSI.State = SCSI_DATA_TO_HOST;
	return -1; /* done with the command */
    }
#endif
    return cmd[OPERATION_CODE]; /* perform the command */
}
#endif
#endif /*USE_USB*/



/*
  put packed string
 */
void putstrp(register __i0 u_int16 *packedStr) {
#if 1//ndef GAPLESS
    while (1) {
	register int i = *packedStr++;
	if (i >> 8) {
	    putch(i >> 8);
	} else {
	    break;
	}
	if (!(i & 255)) {
	    break;
	}
	putch(i);
    }
#endif
}



/* Our own loadcheck which will use fixed 3.5x clock for player
   and 4.0x for USB. */
void GaplessLoadCheck(struct CodecServices *cs, s_int16 n) {
  if (cs == NULL) {
    if (n) {
	clockX = 8; /* USB requires 4.0x! */
	goto set;
    }
    if (clockX != player.maxClock) {
	clockX = player.maxClock; /* Otherwise 3.0-3.5x */
    set:
	SetRate(hwSampleRate);
    }
    return;
  }
  /* cs is always non-NULL here */
  if (cs->gain != player.volumeOffset) {
    player.volumeOffset = cs->gain; /* vorbis-gain */
    PlayerVolume();
  }
}


void MyIdleHook(void) {
#ifdef USE_THREE_BUTTONS
	if (uiTrigger)  {
		uiTrigger = 0;
		NandPutCommand(0);
		KeyScanNoUSB(0x03); //scan D0 and D1 keys only, ignore USB attach
	}
#else
    UserInterfaceIdleHook();
#endif
	if (audioPtr.underflow) {
		USEX(UART_DATA) = 'o';
		audioPtr.underflow = 0;
	}
}

#include <minifat.h>

#if 0
	KeyScanNoUSB(0x1f); /* with feature button */
#endif

void main(void) {
    Enable();

#ifdef GAPLESS
    codecVorbis.audioBegins = 0;
#endif

#if 1 /* This code is required when booting from SPI.
	 You can run this code when booting from NAND.
       */
    clockX = 2;
    InitAudio(); /* goto 3.0x..4.0x */
    PERIP(INT_ENABLEL) = INTF_RX | INTF_TIM0;
    PERIP(INT_ENABLEH) = INTF_DAC;
    ph = FsPhNandCreate(0);
#if 1
    /*
      Because we don't boot from NAND, you don't necessarily have the
      NAND parameters set in the first block.
      If this is the case we set good defaults for NAND128W3A.
     */
    if (((struct FsNandPhys *)ph)->nandType > 5) {
	/* ST NAND128W3A  NAND signature 0x2073 0x2073 params 80/0/5/15 */
	((struct FsNandPhys *)ph)->waitns = 80;
	((struct FsNandPhys *)ph)->nandType = 0;
	ph->eraseBlockSize = 0x20;
	ph->eraseBlocks = 0x400;
    }
#endif
    map = FsMapTnCreate(ph, 0); /* re-initialize tiny mapper */
#endif

    /* Set the leds after nand-boot! */
    PERIP(GPIO1_ODATA) |=  LED1;      /* POWER led on */
    PERIP(GPIO1_DDR)   |=  LED1|LED2; /* SI and SO to outputs */
    PERIP(GPIO1_MODE)  &= ~(LED1|LED2); /* SI and SO to GPIO */

    clockX = player.maxClock;
    SetRate(cs.sampleRate=8000);
    USEX(UART_DIV) = UartDiv();

#ifdef USE_WAV
    /* allow both .WAV and .OGG */
    supportedFiles = defSupportedFiles;
#endif

#ifdef USE_THREE_BUTTONS
	currentKeyMap = threeKeyMap;
#endif

    /* Ignore subdirectories in FAT12 disks */
    SetHookFunction((u_int16)OpenFile, Fat12OpenFile);
    //voltages[voltCorePlayer] = voltages[voltCoreUSB] = 29;//27;
    //voltages[voltIoUSB] = voltages[voltIoPlayer] = 27; /* 3.3V */
    //voltages[voltAnaPlayer] = 30; /*3.6V for high-current MMC/SD!*/
    //PowerSetVoltages(&voltages[voltCorePlayer]);

    SetHookFunction((u_int16)IdleHook, MyIdleHook);   /* no default keyscan */
    //SetHookFunction((u_int16)USBSuspend, NullHook); /* no low-power state */
    SetHookFunction((u_int16)LoadCheck, GaplessLoadCheck); /* fixed clock */

#ifdef USE_USB
    /*fixes SCSI_READ_10 residue problem -- mainly for Linux compatibility,
      does not fix LBAB, but is shorter.. */
    SetHookFunction((u_int16)MSCPacketFromPC, PatchDiskProtocolCommandDE);
#endif/*USE_USB*/

    /* Replicate main loop */
//    player.volume = 17;
//    player.volumeOffset = -24;
    player.pauseOn = 0;
    //player.randomOn = 0;
//    keyOld = KEY_POWER;
//    keyOldTime = -32767; /* ignores the first release of KEY_POWER */

    /* If mapper does not yet exist, create it.
       This way boot code can create a custom mapper
       (and replace the MassStorage() routine). */
    if (!map) {
	map = FsMapTnCreate(ph, 0); /* tiny mapper */
    }

//    player.volume = -24; /* "max" volume */
    PlayerVolume();

//audioPtr.underflow = 1; //test the debug..

    while (1) {
#ifdef USE_USB
	/* If USB is attached, call our version of the MassStorage()
	   handling function. */
	if (USBIsAttached()
#ifdef USE_USB_DISABLE_FILE
		&& (InitFileSystem() != 0 || OpenFileNamed("\pDISABLED", FAT_MKID('U','S','B')) == 0xffff) //enable usb if no FAT or no DISABLED.USB file
#endif
	) {
   	    putstrp("\pUSB Attach\n\n");
	    MyMassStorage();
	    putstrp("\pUSB Detach\n");
#ifdef GAPLESS
	    /* Must clear this after using the vorbis area! */
	    codecVorbis.audioBegins = 0;
#endif
	}
#endif /*USE_USB*/

	/* Try to init FAT. */
	if (InitFileSystem() == 0) {
	    /* Restore the default suffixes. */
	    minifatInfo.supportedSuffixes = supportedFiles;
	    player.totalFiles = OpenFile(0xffffU);
#if 0
	    putstrp("\pfiles");
	    putword(player.totalFiles);
	    putch('\n');
#endif
	    if (player.totalFiles == 0) {
		/* If no files found, output some samples.
		   This causes the idle hook to be called, which in turn
		   scans the keys and you can turn off the unit if you like.
		*/
		putstrp("\pnofiles");
		goto noFSnorFiles;
	    }

	    player.nextStep = 1;
	    player.nextFile = 0;
	    player.currentFile = -1;
	    while (1) {
		player.currentFile = player.nextFile;
		player.nextFile = player.currentFile + 1;

		if (OpenFile(player.currentFile) < 0) {
		    //player.volumeOffset = -12; /*default volume offset*/
		    //PlayerVolume();

		    player.ffCount = 0;
		    cs.cancel = 0;
		    cs.goTo = -1; /* start playing from the start */
		    cs.fileSize = cs.fileLeft = minifatInfo.fileSize;
		    cs.fastForward = 1; /* reset play speed to normal */

#ifndef GAPLESS
		    putstrp("\pplay");
		    //putword(player.currentFile);

		    putword(minifatInfo.fileName[0]);
		    putword(minifatInfo.fileName[1]);
		    putword(minifatInfo.fileName[2]);
		    putword(minifatInfo.fileName[3]);
		    putword(minifatInfo.fileName[4]);
		    putch(minifatInfo.fileName[5]>>8);
		    putch('\n');
#endif

		    
		    PlayerVolume(); /*required for QUIET_CANCEL*/
#ifdef USE_WAV
		    PlayWavOrOggFile();
#else

#ifdef GAPLESS
		    if (codecVorbis.audioBegins) {
			u_int16 data[2];

			Seek(codecVorbis.audioBegins);
			ReadFile(data, 0, 4);
			if (data[0] == 0x4f67 && data[1] == 0x6753) {
			    /* 'OggS', assume the same parameters, skip
			       Vorbis decoder init. */
			    const char *eStr;
			    register s_int16 res = OggSeekHeader(codecVorbis.audioBegins);
			    ogg[1]/*.headerTypeFlag*/ = 0;
			    ogg[6]/*.streamSerialNumber*/ = 0;
			    ogg[7]/*.streamSerialNumber*/ = 0;
			    ogg[14]/*.cont*/ = 0;
			    //ogg.headerTypeFlag = 0;
			    //ogg.cont = 0;
			    vFirstFrame = 1;
			    cs.playTimeSeconds = 0;
			    cs.playTimeSamples = 0;
/*Start decoding without recreating the decoding tables from header.*/
//putch('+');
#ifdef HAS_PATCHCODVORBISDECODE
			    /*available in latest dev1000.h */
			    PatchCodVorbisDecode(&codecVorbis, &cs, &eStr, 0); 
#else
			    /*TODO: call Decode() with silentchannelpatches */
			    CodVorbisDecode(&codecVorbis, &cs, &eStr); 
#endif
			} else {
			    /* 'OggS' Not found, must be a file with
			       different parameters (or WAV) */
//putch('-');
			    Seek(0);
			    PatchPlayCurrentFile();
			}
		    } else {
//putch('n');
			PatchPlayCurrentFile();
		    }
#else
		    PatchPlayCurrentFile();
#endif
#endif
		    player.currentFile = -1;
#ifndef GAPLESS
		    putstrp("\pdone\n");
#endif

		} else {
//putch('x');
		    player.currentFile = -1;
		    player.nextFile = 0;
		}
#ifdef USE_USB
		if (USBIsAttached()) { /* .. or USB is attached. */
		    break;
		}
#endif
	    }
	} else {
	    /* If not a valid FAT (perhaps because MMC/SD is not inserted),
	       just send some samples to audio buffer and try again. */
	    putstrp("\pnofat\n");
	noFSnorFiles:
#ifdef GAPLESS
	    codecVorbis.audioBegins = 0;
#endif
	    LoadCheck(&cs, 32); /* decrease or increase clock */
	    memset(tmpBuf, 0, sizeof(tmpBuf));
	    AudioOutputSamples(tmpBuf, sizeof(tmpBuf)/2);
	    /* When no samples fit, calls the user interface
	       -- handles volume control and power-off. */
	}
    }
}
